<?php
/*
Plugin Name: Kahi's Independent Links
Plugin URI: http://kahi.cz/wordpress/kahis-independent-links-a-plugin/
Description: 
Author: Peter Kahoun aka Kahi
Version: 0.5
Author URI: http://kahi.cz
*/


/**
 * How it works?
 * *****************
 *  
 **/


class KIL {

	// Descr: full name. used on options-page, ...
	static $full_name = 'Kahi\'s Independent Links';

	// Descr: short name. used in menu-item name, ...
	static $short_name = 'Independent Links';

	// Descr: abbreviation. used in textdomain, ...
	// Descr: must be same as the name of the class
	static $abbr = 'kil';

	// Descr: path to this this file
	// filled automatically
	static $dir_name;

	// Descr: path to the cachefile
	// filled automatically
	static private $cache_file_fullname;



	// Descr: initialization. filling main variables, preparing, hooking
	// Descr: constructor replacement (this class is designed to be used as static). calling the initialization: see the end.
	public static function Init () {

		// set self::$dir_name
		$t = str_replace('\\', '/', dirname(__FILE__));
		self::$dir_name = trim(substr($t, strpos($t, '/plugins/')+9), '/');

		// hooking
		add_filter('the_content', array (self::$abbr, 'the_content'), 11); // at the end. Must run after Texy.

	}


// hooked functions ------------------------------------------------------------


	// Hook: Filter: Content
	// Descr: replaces <!--kahis-clean-archives--> with archives
	public static function the_content ($content) {

		$content = preg_replace_callback('/(href=["\'])([0-9]+)(["\'])/', self::$abbr.'::idToUrl', $content);
		return $content;

	}
	
// -----------------------------------------------------------------------------


	// Descr: Callback function of preg_replace_callback(). @see the_content()
	public static function idToUrl ($matches) {
		
		$url = get_permalink($matches[2]);
		if ($url === false) {
			$url = "#post-$matches[2]-not-found"; // seems not to work
		}
		return $matches[1].$url.$matches[3];
		
	}


} // end of class



// Initialize the plugin
KIL::Init();
